# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2021.04.23
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class ListResourcesResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'resources': 'list[Resource]',
        'limit': 'int',
        'page_at_id': 'str'
    }

    attribute_map = {
        'resources': 'resources',
        'limit': 'limit',
        'page_at_id': 'page_at_id'
    }

    def __init__(self, resources=None, limit=None, page_at_id=None, local_vars_configuration=None):  # noqa: E501
        """ListResourcesResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._resources = None
        self._limit = None
        self._page_at_id = None
        self.discriminator = None

        self.resources = resources
        self.limit = limit
        if page_at_id is not None:
            self.page_at_id = page_at_id

    @property
    def resources(self):
        """Gets the resources of this ListResourcesResponse.  # noqa: E501

        The list of matching resources  # noqa: E501

        :return: The resources of this ListResourcesResponse.  # noqa: E501
        :rtype: list[Resource]
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this ListResourcesResponse.

        The list of matching resources  # noqa: E501

        :param resources: The resources of this ListResourcesResponse.  # noqa: E501
        :type: list[Resource]
        """
        if self.local_vars_configuration.client_side_validation and resources is None:  # noqa: E501
            raise ValueError("Invalid value for `resources`, must not be `None`")  # noqa: E501

        self._resources = resources

    @property
    def limit(self):
        """Gets the limit of this ListResourcesResponse.  # noqa: E501

        Limit on the number of rows in the response  # noqa: E501

        :return: The limit of this ListResourcesResponse.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this ListResourcesResponse.

        Limit on the number of rows in the response  # noqa: E501

        :param limit: The limit of this ListResourcesResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and limit is None:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must not be `None`")  # noqa: E501

        self._limit = limit

    @property
    def page_at_id(self):
        """Gets the page_at_id of this ListResourcesResponse.  # noqa: E501

        The id to request in the pagination query to get the next page.  # noqa: E501

        :return: The page_at_id of this ListResourcesResponse.  # noqa: E501
        :rtype: str
        """
        return self._page_at_id

    @page_at_id.setter
    def page_at_id(self, page_at_id):
        """Sets the page_at_id of this ListResourcesResponse.

        The id to request in the pagination query to get the next page.  # noqa: E501

        :param page_at_id: The page_at_id of this ListResourcesResponse.  # noqa: E501
        :type: str
        """

        self._page_at_id = page_at_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListResourcesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ListResourcesResponse):
            return True

        return self.to_dict() != other.to_dict()
