# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2021.04.23
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class ResourceInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'resource_id': 'str',
        'resource_org_id': 'str',
        'resource_type': 'str'
    }

    attribute_map = {
        'resource_id': 'resource_id',
        'resource_org_id': 'resource_org_id',
        'resource_type': 'resource_type'
    }

    def __init__(self, resource_id=None, resource_org_id=None, resource_type=None, local_vars_configuration=None):  # noqa: E501
        """ResourceInfo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._resource_id = None
        self._resource_org_id = None
        self._resource_type = None
        self.discriminator = None

        self.resource_id = resource_id
        self.resource_org_id = resource_org_id
        self.resource_type = resource_type

    @property
    def resource_id(self):
        """Gets the resource_id of this ResourceInfo.  # noqa: E501

        The unique identifier of the resource.  # noqa: E501

        :return: The resource_id of this ResourceInfo.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ResourceInfo.

        The unique identifier of the resource.  # noqa: E501

        :param resource_id: The resource_id of this ResourceInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_id is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_id`, must not be `None`")  # noqa: E501

        self._resource_id = resource_id

    @property
    def resource_org_id(self):
        """Gets the resource_org_id of this ResourceInfo.  # noqa: E501

        The organisation id corresponding to the organisation which administers the resource granted permissions by this.   # noqa: E501

        :return: The resource_org_id of this ResourceInfo.  # noqa: E501
        :rtype: str
        """
        return self._resource_org_id

    @resource_org_id.setter
    def resource_org_id(self, resource_org_id):
        """Sets the resource_org_id of this ResourceInfo.

        The organisation id corresponding to the organisation which administers the resource granted permissions by this.   # noqa: E501

        :param resource_org_id: The resource_org_id of this ResourceInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_org_id is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_org_id`, must not be `None`")  # noqa: E501

        self._resource_org_id = resource_org_id

    @property
    def resource_type(self):
        """Gets the resource_type of this ResourceInfo.  # noqa: E501

        The type of resource. This describes how the resource can be accessed, its purpose, etc. In this particular context, it is useful mostly for display purposes.   # noqa: E501

        :return: The resource_type of this ResourceInfo.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ResourceInfo.

        The type of resource. This describes how the resource can be accessed, its purpose, etc. In this particular context, it is useful mostly for display purposes.   # noqa: E501

        :param resource_type: The resource_type of this ResourceInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_type is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_type`, must not be `None`")  # noqa: E501

        self._resource_type = resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ResourceInfo):
            return True

        return self.to_dict() != other.to_dict()
